﻿using UnityEngine;
using UnityEngine.SceneManagement;

public class GameManager : MonoBehaviour
{
    public float DeathSpeed = 5f;
    public float DangerousSpeed = 3f;
    public float StartShipFuel = 20f;
    public float FuelLossRatePerSecond = 0.2f;

    public AudioClip explodesound;
    public GameObject endGameScreenObject;

    private EndGameScreen endGameScreen;
    private AudioSource audioSource;

    void Start()
    {
        if (endGameScreenObject == null) {
            return;
        }

        endGameScreen = endGameScreenObject.GetComponent<EndGameScreen>();
        audioSource = GetComponent<AudioSource>();
    }

    void Update()
    {
    }

    public void EndOfFuel()
    {
        Debug.LogError("Całe paliwo poszło w chuj!");
        EndGameWithFail(
            "You have used all your fuel!", 
            "You need to collect the fuel barrels to get home.");
    }

    public void ZapierdolilOWyspe(GameObject player)
    {
        Debug.LogError("Koniec gry! Gracz wypierdolił w wyspę! Za szybko !");
        audioSource.PlayOneShot(explodesound, 0.5F);
        EndGameWithFail(
            "You crashed into an island.", 
            "You have to watch out for them.");
    }

    public void WirCieWciagnalPalko()
    {
        Debug.LogError("Wir matole!");

        EndGameWithFail(
            "You have been sucked by vortex",
            "Try to avoid them if possible, or pass nearby with hi speed!");
    }

    public void ExplosionMine() {

        Debug.LogError("Mina !");

        EndGameWithFail(
            "You have died due to water mine.",
            "Try to avoid them.");
    }

    public void Retry()
    {
        Debug.Log("Retry clicked");
        SceneManager.LoadScene("MainScene");
    }

    private void EndGameWithFail(string casue, string hint)
    {
        if (endGameScreenObject == null) {
            return;
        }

        endGameScreen.UpdateTexts(casue, hint);
        endGameScreenObject.SetActive(true);
    }

    public void JebnalStatek()
    {
        Debug.LogError("Statek !");

        EndGameWithFail(
            "Ship of pirates! They drowned you.",
            "Try to avoid them.");
    }

    public void GraczSiePoddal()
    {
        EndGameWithFail(
            "Why you give up ?",
            "Try to save Tom again!");
    }

    public void Success()
    {
        EndGameWithFail("CONGRATULATIONS", "You found your sweet HOME !");
    }
}
