﻿using System.Collections;
using System.Collections.Generic;
using System.Security.Cryptography;
using Assets.Scripts.Triggers;
using UnityEngine;
using UnityEngine.AI;

public class PirateShip : MonoBehaviour, ISegment
{
    public Transform Goal;

    private NavMeshAgent agent;
    private PlayerContoller player;
    private GameManager gameManager;

    private bool stalking = false;

    void Awake()
    {
        agent = GetComponent<NavMeshAgent>();
        player = GameObject.FindGameObjectWithTag(Tags.Player).GetComponent<PlayerContoller>();
        gameManager = GameObject.FindGameObjectWithTag(Tags.GameManager).GetComponent<GameManager>();
    }

    public void Stalking()
    {
        agent.destination = Goal.position;
    }

    void Update()
    {
        if (stalking)
        {
            Stalking();
        }
    }

    private void OnTriggerEnter(Collider other)
    {
        if (other.transform.root.tag == Tags.Player)
        {
            stalking = true;
        }
    }

    public void OnSegmentEnter(Collider other)
    {
        if (other.transform.root.tag == Tags.Player)
        {
            player.GameOver(() => gameManager.JebnalStatek());
        }
    }

    public void OnSegmentExit(Collider other)
    {
    }
}
