﻿using UnityEngine;

namespace Assets.Scripts
{
    public class CameraFollowing: MonoBehaviour
    {
        private PlayerContoller _playerController;
        private Vector3 _offest;

        private void Awake()
        {
            _playerController = GameObject.FindGameObjectWithTag(Tags.Player)
                .GetComponent<PlayerContoller>();
        }

        private void Start()
        {
            _offest = Camera.main.transform.position - _playerController.transform.position;
        }

        private void Update()
        {
            if (_playerController.IsShipDestroyed)
                return;

            Camera.main.transform.position = _playerController.transform.position + _offest;
        }
    }
}
