﻿using UnityEngine;

namespace Assets.Scripts.Entities
{
    public class VortexForce: MonoBehaviour
    {
        public float DragForce = 2f;
        private bool _useForceOnBoat = false;
        private PlayerContoller _playerContoller;

        private void Awake()
        {
            _playerContoller = GameObject.FindGameObjectWithTag(Tags.GameManager)
                .GetComponent<PlayerContoller>();
        }

        private void OnTriggerEnter(Collider other)
        {
            if(other.transform.root.tag == Tags.Player)
            {
                _useForceOnBoat = true;
            }
        }

        private void OnTriggerExit(Collider other)
        {
            if (other.transform.root.tag == Tags.Player)
            {
                _useForceOnBoat = false;
            }
        }

        private void Update()
        {
            if (_useForceOnBoat)
            {
                Vector3 forceVector = transform.position - _playerContoller.transform.position;

                _playerContoller.GetComponent<Rigidbody>().AddForce(forceVector, ForceMode.Force);
            }
        }
    }
}
