﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class MineScript : MonoBehaviour
{
    public GameObject boom;
    private float accumulator = 0;
    private GameManager manager;
    private ExplosionMat explosion = null;

    private void Awake()
    {
        manager = GameObject.FindGameObjectWithTag(Tags.GameManager).GetComponent<GameManager>();
    }

    // Start is called before the first frame update
    void Start()
    {
        
    }

    // Update is called once per frame
    void Update()
    {
        Vector3 pos = transform.position;
        pos.y = (Mathf.Sin(accumulator * 2.0f) * 0.2f) + 0.5f;
        transform.position = pos;

        accumulator += Time.deltaTime;

        if (explosion != null) {

            explosion._alpha -= Time.deltaTime;
            explosion._alpha = Mathf.Max(0, explosion._alpha);
            explosion.UpdateShaderProperties();

            if (explosion._alpha == 0) {
               
                GameObject.Destroy(this.gameObject);
            }
        }
    }

    private void OnCollisionEnter(Collision collision)
    {
        if (collision.gameObject.transform.root.tag == Tags.Player && explosion == null) { 

            GameObject pObject = collision.gameObject;

            GameObject loaded = Instantiate(boom, transform.position, Quaternion.identity);

            PlayerContoller controller = pObject.GetComponent<PlayerContoller>();
            controller.GameOver(() => manager.ExplosionMine());

            explosion = loaded.GetComponent<ExplosionMat>();
            explosion._alpha = 1.0f;
            explosion.UpdateShaderProperties();
        }
    }
}
