﻿using UnityEngine;
using System.Collections;

public class PlanetMovement : MonoBehaviour {

	public float planeSize = 10.0f;

	private float axisX = 0.0f;
	private float axisY = 0.0f;
	private float lastAxisX = 0.0f;
	private float lastAxisY = 0.0f;

	private float maxMovementSpeed = 2.0f;
	private float maxStepSize = 1.0f;

	void Start () {
	
#if UNITY_IPHONE || UNITY_ANDROID
		lastAxisX = 0.2f;
		lastAxisY = 0.2f;
#endif

	}
	
	void Update () {

#if UNITY_IPHONE || UNITY_ANDROID

		if(Input.touchCount == 1){

			Touch touch = Input.GetTouch(0);

			axisX = 0.0f;
			axisX = 0.0f;

			if(touch.phase == TouchPhase.Stationary) {

				Vector3 dir = Vector3.zero;
				dir.x = Input.acceleration.x;
				dir.z = -Input.acceleration.z;

				if (dir.sqrMagnitude > 1)
					dir.Normalize();

				axisX = dir.x;
				axisY = dir.z;
			}
		
		}
		else{
			
			axisX = 0.0f;
			axisY = 0.0f;
		}
				
#else
		axisX = Input.GetAxis("Horizontal");
		axisY = Input.GetAxis("Vertical");
#endif


		if( axisX > lastAxisX ) {

			transform.position = Vector3.Lerp(transform.position, transform.position + new Vector3(maxStepSize, 0.0f, 0.0f), maxMovementSpeed*Time.deltaTime);

		}else if( axisX < -lastAxisX ) {

			transform.position = Vector3.Lerp(transform.position, transform.position - new Vector3(maxStepSize, 0.0f, 0.0f), maxMovementSpeed*Time.deltaTime);
		}

		if(axisY > lastAxisY) {
			
			transform.position = Vector3.Lerp(transform.position, transform.position + new Vector3(0.0f, 0.0f, maxStepSize), maxMovementSpeed*Time.deltaTime);
			
		}else if(axisY < -lastAxisY) {
			
			transform.position = Vector3.Lerp(transform.position, transform.position - new Vector3(0.0f, 0.0f, maxStepSize), maxMovementSpeed*Time.deltaTime);
		}

		Vector3 currPos = transform.position;

		if(currPos.z > planeSize){
			currPos.z -= 2.0f * planeSize;
		}

		if(currPos.z < -planeSize) {
			currPos.z += 2.0f * planeSize;
		}

		if(currPos.x > planeSize){
			currPos.x -= 2.0f * planeSize;
		}

		if(currPos.x < -planeSize){
			currPos.x += 2.0f * planeSize;
		}

		transform.position = currPos;
	}
}
