﻿using Assets.Scripts.Triggers;
using UnityEngine;

public class SegmentTrigger : MonoBehaviour
{
    public string SegmentName;

    private ISegment parent;
    private bool isInside;

    void Awake()
    {
        isInside = false;
        parent = transform.parent.GetComponent<ISegment>();
    }

    private void OnTriggerEnter(Collider other)
    {
        if (isInside)
        {
            return;
        }

        isInside = true;
        parent.OnSegmentEnter(other);
    }

    private void OnTriggerExit(Collider other)
    {
        if (!isInside)
        {
            return;
        }

        isInside = false;
        parent.OnSegmentExit(other);
    }
}
