﻿using UnityEngine;
using UnityEngine.UI;

namespace Assets.Scripts.UI
{
    public class FuelMeter: MonoBehaviour
    {
        public Image FuelImage;
        private GameManager _controller;
        private PlayerContoller _player;
        private float _maxHeight;
        private Vector2 _anchoredPositionStart;

        private void Awake()
        {
            _controller = GameObject.FindGameObjectWithTag(Tags.GameManager)
                .GetComponent<GameManager>();

            _player = GameObject.FindGameObjectWithTag(Tags.Player)
                .GetComponent<PlayerContoller>();
        }

        private void Start()
        {
            _maxHeight = FuelImage.rectTransform.sizeDelta.y;
            _anchoredPositionStart = new Vector2(FuelImage.rectTransform.anchoredPosition.x, 
                FuelImage.rectTransform.anchoredPosition.y - FuelImage.rectTransform.sizeDelta.y/2);
            FuelImage.rectTransform.anchoredPosition = _anchoredPositionStart;
        }

        private void Update()
        {
            float heightBasedOnFuel = (_player.CurrentFuel / _player.ShipsMaxFuel) * _maxHeight;

            FuelImage.rectTransform.sizeDelta = new Vector2(
                FuelImage.rectTransform.sizeDelta.x, 
                Mathf.Min(heightBasedOnFuel, _maxHeight));

            float finalPosition = _anchoredPositionStart.y + FuelImage.rectTransform.sizeDelta.y/2;

            FuelImage.rectTransform.anchoredPosition = new Vector2(
                FuelImage.rectTransform.anchoredPosition.x, 
                finalPosition);
        }
    }
}
