﻿using System.Collections;
using UnityEngine;

namespace Assets.Scripts.UI
{
    public class WindDirectionUI: MonoBehaviour
    {
        public GameObject WindImage;
        public WindController Wind;

        private float _lastAngle;

        private void Update()
        {
            SetWindDirectionOnUI();
        }

        private void SetWindDirectionOnUI()
        {
            Vector3 windDirection = Wind.ForceVector.normalized;
            float angle = Vector3.Angle(Vector3.left, windDirection);

            if(Wind.ForceVector.z > 0)
            {
                angle = -angle;
            }

            if (!Mathf.Approximately(angle, _lastAngle))
            {
                float toAngle = angle;
                float currentANgle = WindImage.transform.localEulerAngles.z;

                if(currentANgle > 180)
                {
                    currentANgle = currentANgle - 360;
                }

                StartCoroutine(RotateTowards(currentANgle, toAngle));
                _lastAngle = angle;
            }
        }

        private IEnumerator RotateTowards(float floatAngleStart, float AngleTo)
        {
            float steps = 10;
            float currentStep = 0;

            while (currentStep < steps)
            {
                float rotationAngle = Mathf.Lerp(floatAngleStart, AngleTo, currentStep / steps);
                WindImage.transform.localEulerAngles = new Vector3(0f, 0f, rotationAngle);
                currentStep++;
                yield return new WaitForEndOfFrame();
            }
        }
    }
}
