﻿Shader "Custom/CircleShader" {
	Properties {
		_MainTex ("Base (RGB)", 2D) = "white" {}
		_EnableCurve ("Curve", float) = 1.0
		_Color ("Color (RGB)", Color) = (1.0,1.0,1.0,1.0)
	}
	SubShader {
		Tags { "RenderType"="Opaque" }
		LOD 1000
		//Cull off
		
		CGPROGRAM
		#pragma surface surf Lambert vertex:vert

		sampler2D _MainTex;
		float _EnableCurve;
		float4 _Color;

		struct Input {
			float2 uv_MainTex;
		};
		
		void vert (inout appdata_full v) {
		
			if(_EnableCurve > 0.0){
        	  v.vertex.y -= (v.vertex.x * v.vertex.x + v.vertex.z * v.vertex.z);
        	  v.normal.y += (v.normal.x * v.normal.x + v.normal.z * v.normal.z);
        	}
        }

		void surf (Input IN, inout SurfaceOutput o) {
			half4 c = tex2D (_MainTex, IN.uv_MainTex);
			o.Albedo = c.rgb * _Color.rgb;
			o.Alpha = c.a;
		}
		ENDCG
	} 
	FallBack "Diffuse"
}
