﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class VortexAnim : MonoBehaviour
{
    public float dragForce = 20;

    private GameObject player;
    private Vector3 direction;
    private bool sink = false;
    private GameManager manager;

    private void Awake()
    {
        manager = GameObject.FindGameObjectWithTag(Tags.GameManager).GetComponent<GameManager>();
    }

    // Start is called before the first frame update
    void Start()
    {
    }

    // Update is called once per frame
    void Update()
    {
        transform.Rotate(Vector3.up * (200.0f * Time.deltaTime));

        if (sink) {

            Vector3 pos = transform.position;
            pos.y -= 15 * Time.deltaTime;
            transform.position = pos;

            return;
        }

        if (player == null) {
            direction = Vector3.zero;
            return;
        }

        direction = transform.position - player.transform.position;
        direction.Normalize();

        float distance = Vector3.Distance(transform.position, player.transform.position);

        if (distance < 0.5) {

            sink = true;

            PlayerContoller controller = player.GetComponent<PlayerContoller>();
            controller.GameOver(() => manager.WirCieWciagnalPalko());

            player = null;
        }
    }

    private void FixedUpdate()
    {
        if (player == null) {
            return;
        }

        Rigidbody rigid = player.gameObject.GetComponent<Rigidbody>();

        rigid.AddForce(direction * dragForce, ForceMode.Force);
    }

    private void OnTriggerEnter(Collider other)
    {
        if (other.transform.root.tag == Tags.Player) {
        
            player = other.transform.root.gameObject;
        }
    }

    private void OnTriggerExit(Collider other)
    {
        if (other.transform.root.tag == Tags.Player)
        {
            player = null;
        }
    }
}
